// ****************************************************************************************************
// CHEETAH2.INC - CHEETAH DATABASE SYSTEM DLL DECLARES
//
// DECLARES for the Aurora COMPILER.
// Created: 02-14-2006
// Lars Viklund
// lasse@larsviklund.com
// ****************************************************************************************************

#use "cheetah2.lib"

// ----------------------------------------------------------------------------------------------------
// DATABASE ROUTINES - Creation/Opening/Closing 
// ----------------------------------------------------------------------------------------------------
     declare import, xdbCreate Alias "XDBCREATE" (dbFile as string, FieldArray[] as string);
     declare import, xdbCreate_Z Alias "XDBCREATE_Z" (dbFile As string, AllFields As string);
     declare import, xdbCreateExtended Alias "XDBCREATEEXTENDED" (tFileName as string, FieldArray[] as string, MemoBlockSize as int, Algorithm as int, EncryptionKey as string) ;
     declare import, xdbCreateExtended_Z Alias "XDBCREATEEXTENDED_Z" (tFileName As string, AllFields As string, MemoBlockSize as int, Algorithm as int, EncryptionKey As string) ;
     declare import, xdbOpen Alias "XDBOPEN" (dbFile as string, opt EncryptionKey as string), int;
     declare import, xdbOpen_Z Alias "XDBOPEN_Z" (dbFile As string, opt EncryptionKey As string), int;
     declare import, xdbOpenEX Alias "XDBOPENEX" (dbFile as string, AccessMode as int, ShareMode as int, opt EncryptionKey as string), int;
     declare import, xdbOpenEX_Z Alias "XDBOPENEX_Z" (dbFile As string, AccessMode as int, ShareMode as int, opt EncryptionKey As string), int;
     declare import, xdbAlias Alias "XDBALIAS" (dbHandle as int);
     declare import, xdbAlias_Z Alias "XDBALIAS_Z" (dbHandle as int), int;
     declare import, xdbSetAlias Alias "XDBSETALIAS" (dbHandle as int, AliasName as string);
     declare import, xdbSetAlias_Z Alias "XDBSETALIAS_Z" (dbHandle as int, AliasName As string);
     declare import, xdbCreateFields Alias "XDBCREATEFIELDS" (mFileName as string);
     declare import, xdbCreateFields_Z Alias "XDBCREATEFIELDS_Z" (mFileName As string);
     declare import, xdbCreateFieldsExtended Alias "XDBCREATEFIELDSEXTENDED" (mFileName as string, MemoBlockSize as int, Algorithm as int, EncryptionKey as string) ;
     declare import, xdbCreateFieldsExtended_Z Alias "XDBCREATEFIELDSEXTENDED_Z" (mFileName As string, MemoBlockSize as int, Algorithm as int, EncryptionKey As string) ;
     declare import, xdbAddField Alias "XDBADDFIELD" (FieldInfoString as string);
     declare import, xdbAddField_Z Alias "XDBADDFIELD_Z" (FieldInfoString As string);
     declare import, xdbClose Alias "XDBCLOSE" (dbHandle as int);
     declare import, xdbClose_Z Alias "XDBCLOSE_Z" (dbHandle as int);
     declare import, xdbCloseAllIndexes Alias "XDBCLOSEALLINDEXES" (dbHandle as int);
     declare import, xdbCloseAllIndexes_Z Alias "XDBCLOSEALLINDEXES_Z" (dbHandle as int);

// ----------------------------------------------------------------------------------------------------
// DATABASE ROUTINES - MultiUser  as int Locking  
// ----------------------------------------------------------------------------------------------------
     declare import, xdbMultiUser Alias "XDBMULTIUSER" (TrueFalse as int, NumRetries as int, WaitTime as int) ;
     declare import, xdbMultiUser_Z Alias "XDBMULTIUSER_Z" (TrueFalse as int, NumRetries as int, WaitTime as int) ;
     declare import, xdbMultiThreaded Alias "XDBMULTITHREADED" (OnOff As int), int;
     declare import, xdbFailedLockInfo Alias "XDBFAILEDLOCKINFO" (DBFhandle as int, Reason as string, Username as string, Workstation as string, LockDate as string, LockTime as string) ;
     declare import, xdbFailedLockInfo_Z Alias "XDBFAILEDLOCKINFO_Z" (DBFhandle as int, zReason As int, zUsername As int, zWorkstation As int, zLockDate As int, zLockTime As int) ;
     declare import, xdbActivate Alias "XDBACTIVATE" (ActivateNumber As int) ;
     declare import, xdbActivate_Z Alias "XDBACTIVATE_Z" (ActivateNumber As int) ;
     declare import, xdbSetExclusiveLock Alias "XDBSETEXCLUSIVELOCK" (DBFhandle as int), uint;
     declare import, xdbSetExclusiveLock_Z Alias "XDBSETEXCLUSIVELOCK_Z" (DBFhandle as int), uint;
     declare import, xdbRemoveExclusiveLock Alias "XDBREMOVEEXCLUSIVELOCK" (DBFhandle as int, LOCK_NUM as int) ;
     declare import, xdbRemoveExclusiveLock_Z Alias "XDBREMOVEEXCLUSIVELOCK_Z" (DBFhandle as int, LOCK_NUM as int) ;
     declare import, xdbSetEditLock Alias "XDBSETEDITLOCK" (DBFhandle as int, RecordNumber as int), int;
     declare import, xdbSetEditLock_Z Alias "XDBSETEDITLOCK_Z" (DBFhandle as int, RecordNumber as int), int;
     declare import, xdbRemoveEditLock Alias "XDBREMOVEEDITLOCK" (DBFhandle as int, LOCK_NUM as int);
     declare import, xdbRemoveEditLock_Z Alias "XDBREMOVEEDITLOCK_Z" (DBFhandle as int, LOCK_NUM as int);
     declare import, xdbIsEditLock Alias "XDBISEDITLOCK" (DBFhandle as int, RecordNumber as int), int;
     declare import, xdbIsEditLock_Z Alias "XDBISEDITLOCK_Z" (DBFhandle as int, RecordNumber as int), int;

// ----------------------------------------------------------------------------------------------------
// DATABASE ROUTINES - Adding/Deleting Records 
// ----------------------------------------------------------------------------------------------------
     declare import, xdbAddRecord Alias "XDBADDRECORD" (dbHandle as int);
     declare import, xdbAddRecord_Z Alias "XDBADDRECORD_Z" (dbHandle as int);
     declare import, xdbAppendRecord Alias "XDBAPPENDRECORD" (DBFhandle as int);
     declare import, xdbAppendRecord_Z Alias "XDBAPPENDRECORD_Z" (DBFhandle as int);
     declare import, xdbClearBuffer Alias "XDBCLEARBUFFER" (dbHandle as int);
     declare import, xdbClearBuffer_Z Alias "XDBCLEARBUFFER_Z" (dbHandle as int);
     declare import, xdbPutRecord Alias "XDBPUTRECORD" (dbHandle as int, RN as int);
     declare import, xdbPutRecord_Z Alias "XDBPUTRECORD_Z" (dbHandle as int, RN as int);
     declare import, xdbGetRecord Alias "XDBGETRECORD" (dbHandle as int, RN as int);
     declare import, xdbGetRecord_Z Alias "XDBGETRECORD_Z" (dbHandle as int, RN as int);
     declare import, xdbDeleteRecord Alias "XDBDELETERECORD" (DBFhandle as int, RecordNumber as int);
     declare import, xdbDeleteRecord_Z Alias "XDBDELETERECORD_Z" (DBFhandle as int, RecordNumber as int);
     declare import, xdbRecallRecord Alias "XDBRECALLRECORD" (DBFhandle as int, RecordNumber as int);
     declare import, xdbRecallRecord_Z Alias "XDBRECALLRECORD_Z" (DBFhandle as int, RecordNumber as int);
     declare import, xdbDeleted Alias "XDBDELETED" (DBFhandle as int, RecordNumber as int), int;
     declare import, xdbDeleted_Z Alias "XDBDELETED_Z" (DBFhandle as int, RecordNumber as int), int;
     declare import, xdbFlushDatabase Alias "XDBFLUSHDATABASE" (dbHandle as int);
     declare import, xdbFlushDatabase_Z Alias "XDBFLUSHDATABASE_Z" (dbHandle as int);
     declare import, xdbPack Alias "XDBPACK" ( DBFhandle as int);
     declare import, xdbPack_Z Alias "XDBPACK_Z" ( DBFhandle as int);
     declare import, xdbZap Alias "XDBZAP" ( DBFhandle as int);
     declare import, xdbZap_Z Alias "XDBZAP_Z" ( DBFhandle as int);
     declare import, xdbRecordBuffer Alias "XDBRECORDBUFFER" (DBFhandle as int);
     declare import, xdbRecordBuffer_Z Alias "XDBRECORDBUFFER_Z" (DBFhandle as int), int;
     declare import, xdbSpeedAppend Alias "XDBSPEEDAPPEND" (DBFhandle as int, TrueFalse as int);
     declare import, xdbSpeedAppend_Z Alias "XDBSPEEDAPPEND_Z" (DBFhandle as int, TrueFalse as int);

// ----------------------------------------------------------------------------------------------------
// DATABASE ROUTINES - Database Information
// ----------------------------------------------------------------------------------------------------
     declare import, xdbRecordCount Alias "XDBRECORDCOUNT" (dbHandle as int), int;
     declare import, xdbRecordCount_Z Alias "XDBRECORDCOUNT_Z" (dbHandle as int), int;
     declare import, xdbFieldCount Alias "XDBFIELDCOUNT" (dbHandle as int), int;
     declare import, xdbFieldCount_Z Alias "XDBFIELDCOUNT_Z" (dbHandle as int), int;
     declare import, xdbFieldNumber Alias "XDBFIELDNUMBER" (dbHandle as int, FieldName as string), int;
     declare import, xdbFieldNumber_Z Alias "XDBFIELDNUMBER_Z" (dbHandle as int, FieldName As string), int;
     declare import, xdbRecordNumber Alias "XDBRECORDNUMBER" (DBFhandle as int), int;
     declare import, xdbRecordNumber_Z Alias "XDBRECORDNUMBER_Z" (DBFhandle as int), int;
     declare import, xdbLastUpdated Alias "XDBLASTUPDATED" (dbHandle as int, YearNr as int, MonthNr as int, DayNr as int);
     declare import, xdbLastUpdated_Z Alias "XDBLASTUPDATED_Z" (dbHandle as int, YearNr as int, MonthNr as int, DayNr as int);
     declare import, xdbFieldInfo Alias "XDBFIELDINFO" (DBFhandle as int, FieldNumber as int, FieldName as string, FieldType as string, FieldLength as int, FieldDecimals as int);
     declare import, xdbFieldInfo_Z Alias "XDBFIELDINFO_Z" (DBFhandle as int, FieldNumber as int, zFieldName as int, zFieldType as int, FieldLength as int, FieldDecimals as int);
     declare import, xdbFieldName Alias "XDBFIELDNAME" (DBFhandle as int, FieldNumber as int);
     declare import, xdbFieldName_Z Alias "XDBFIELDNAME_Z" (DBFhandle as int, FieldNumber as int), int;
     declare import, xdbFieldType Alias "XDBFIELDTYPE" (DBFhandle as int, FieldNumber as int);
     declare import, xdbFieldType_Z Alias "XDBFIELDTYPE_Z" (DBFhandle as int, FieldNumber as int), int;
     declare import, xdbFieldLength Alias "XDBFIELDLENGTH" (DBFhandle as int, FieldNumber as int), int;
     declare import, xdbFieldLength_Z Alias "XDBFIELDLENGTH_Z" (DBFhandle as int, FieldNumber as int), int;
     declare import, xdbFieldDecimals Alias "XDBFIELDDECIMALS" (DBFhandle as int, FieldNumber as int), int;
     declare import, xdbFieldDecimals_Z Alias "XDBFIELDDECIMALS_Z" (DBFhandle as int, FieldNumber as int), int;
     declare import, xdbDatabaseHandles Alias "XDBDATABASEHANDLES" (DBFfilename as string, CheetahHandle as int, WindowsHandle as int);
     declare import, xdbDatabaseHandles_Z Alias "XDBDATABASEHANDLES_Z" (DBFfilename As string, CheetahHandle as int, WindowsHandle as int);
     declare import, xdbIndexHandles Alias "XDBINDEXHANDLES" (IDXfilename as string, CheetahHandle as int, WindowsHandle as int);
     declare import, xdbIndexHandles_Z Alias "XDBINDEXHANDLES_Z" (IDXfilename As string, CheetahHandle as int, WindowsHandle as int);

// ----------------------------------------------------------------------------------------------------
// DATABASE ROUTINES - Navigating the Database 
// ----------------------------------------------------------------------------------------------------
     declare import, xdbEOF Alias "XDBEOF" (DBFhandle as int), int;
     declare import, xdbEOF_Z Alias "XDBEOF_Z" (DBFhandle as int), int;
     declare import, xdbBOF Alias "XDBBOF" (DBFhandle as int), int;
     declare import, xdbBOF_Z Alias "XDBBOF_Z" (DBFhandle as int), int;
     declare import, xdbMoveFirst Alias "XDBMOVEFIRST" (DBFhandle as int, idxHandle as int);
     declare import, xdbMoveFirst_Z Alias "XDBMOVEFIRST_Z" (DBFhandle as int, idxHandle as int);
     declare import, xdbMoveNext Alias "XDBMOVENEXT" (DBFhandle as int, idxHandle as int);
     declare import, xdbMoveNext_Z Alias "XDBMOVENEXT_Z" (DBFhandle as int, idxHandle as int);
     declare import, xdbMoveLast Alias "XDBMOVELAST" (DBFhandle as int, idxHandle as int);
     declare import, xdbMoveLast_Z Alias "XDBMOVELAST_Z" (DBFhandle as int, idxHandle as int);
     declare import, xdbMovePrev Alias "XDBMOVEPREV" (DBFhandle as int, idxHandle as int);
     declare import, xdbMovePrev_Z Alias "XDBMOVEPREV_Z" (DBFhandle as int, idxHandle as int);
     declare import, xdbSkipDeleted Alias "XDBSKIPDELETED" (DBFhandle as int, TrueFalse as int);
     declare import, xdbSkipDeleted_Z Alias "XDBSKIPDELETED_Z" (DBFhandle as int, TrueFalse as int);
     declare import, xdbKeyPosition Alias "XDBKEYPOSITION" (DBFhandle as int, IDXhandle as int, KeyPosition as int), int;
     declare import, xdbKeyPosition_Z Alias "XDBKEYPOSITION_Z" (DBFhandle as int, IDXhandle as int, KeyPosition as int), int;

// ----------------------------------------------------------------------------------------------------
// DATABASE ROUTINES - Assigning Field Values 
// ----------------------------------------------------------------------------------------------------
     declare import, xdbAssignField Alias "XDBASSIGNFIELD" (dbHandle as int, FieldName as string, FieldNumber as int, FieldString as string);
     declare import, xdbAssignField_Z Alias "XDBASSIGNFIELD_Z" (dbHandle as int, FieldName As string, FieldNumber as int, FieldString As string);
     declare import, xdbAssignMemo_Z Alias "XDBASSIGNMEMO_Z" (dbHandle as int, zFieldName As string, FieldNumber as int, MemAddress as int, StringLength as int);
     declare import, xdbAssignFieldINT Alias "XDBASSIGNFIELDINT" (dbHandle as int, FieldName as string, FieldNumber as int, FieldInteger as int);
     declare import, xdbAssignFieldINT_Z Alias "XDBASSIGNFIELDINT_Z" (dbHandle as int, FieldName As string, FieldNumber as int, FieldInteger as int);
     declare import, xdbAssignFieldLNG Alias "XDBASSIGNFIELDLNG" (dbHandle as int, FieldName as string, FieldNumber as int, FieldLong as int);
     declare import, xdbAssignFieldLNG_Z Alias "XDBASSIGNFIELDLNG_Z" (dbHandle as int, FieldName As string, FieldNumber as int, FieldLong as int);
     declare import, xdbAssignFieldSNG Alias "XDBASSIGNFIELDSNG" (dbHandle as int, FieldName as string, FieldNumber as int, FieldSingle as float);
     declare import, xdbAssignFieldSNG_Z Alias "XDBASSIGNFIELDSNG_Z" (dbHandle as int, FieldName As string, FieldNumber as int, FieldSingle as float);
     declare import, xdbAssignFieldDBL Alias "XDBASSIGNFIELDDBL" (dbHandle as int, FieldName as string, FieldNumber as int, FieldDouble as double);
     declare import, xdbAssignFieldDBL_Z Alias "XDBASSIGNFIELDDBL_Z" (dbHandle as int, FieldName As string, FieldNumber as int, FieldDouble as double);
//     declare import, xdbAssignFieldCUR Alias "XDBASSIGNFIELDCUR" (dbHandle as int, FieldName as string, FieldNumber as int, FieldCurrency@);
//     declare import, xdbAssignFieldCUR_Z Alias "XDBASSIGNFIELDCUR_Z" (dbHandle as int, FieldName As string, FieldNumber as int, FieldCurrency@);

// ----------------------------------------------------------------------------------------------------
// DATABASE ROUTINES - Retrieving Field Values 
// ----------------------------------------------------------------------------------------------------
     declare import, xdbMemoValueLen_Z Alias "XDBMEMOVALUELEN_Z" (DBFhandle as int, FieldName As string, FieldCode as int), int;
     declare import, xdbMemoValueAddr_Z Alias "XDBMEMOVALUEADDR_Z" (DBFhandle as int, FieldName As string, FieldCode as int), int;
     declare import, xdbFieldValue Alias "XDBFIELDVALUE" (DBFhandle as int, FieldName as string, FieldCode as int);
     declare import, xdbFieldValue_Z Alias "XDBFIELDVALUE_Z" (DBFhandle as int, FieldName As string, FieldCode as int), int;
     declare import, xdbFieldValueINT Alias "XDBFIELDVALUEINT" (DBFhandle as int, FieldName as string, FieldCode as int), int;
     declare import, xdbFieldValueINT_Z Alias "XDBFIELDVALUEINT_Z" (DBFhandle as int, FieldName As string, FieldCode as int), int;
     declare import, xdbFieldValueLNG Alias "XDBFIELDVALUELNG" (DBFhandle as int, FieldName as string, FieldCode as int), int;
     declare import, xdbFieldValueLNG_Z Alias "XDBFIELDVALUELNG_Z" (DBFhandle as int, FieldName As string, FieldCode as int), int;
     declare import, xdbFieldValueSNG Alias "XDBFIELDVALUESNG" (DBFhandle as int, FieldName as string, FieldCode as int), float;
     declare import, xdbFieldValueSNG_Z Alias "XDBFIELDVALUESNG_Z" (DBFhandle as int, FieldName As string, FieldCode as int), float;
     declare import, xdbFieldValueDBL Alias "XDBFIELDVALUEDBL" (DBFhandle as int, FieldName as string, FieldCode as int), double;
     declare import, xdbFieldValueDBL_Z Alias "XDBFIELDVALUEDBL_Z" (DBFhandle as int, FieldName As string, FieldCode as int), double;
//     declare import, xdbFieldValueCUR@ Alias "XDBFIELDVALUECUR" (DBFhandle as int, FieldName as string, FieldCode as int);
//     declare import, xdbFieldValueCUR_Z@ Alias "XDBFIELDVALUECUR_Z" (DBFhandle as int, FieldName As string, FieldCode as int);
     declare import, xdbFieldPadding Alias "XDBFIELDPADDING" (DBFhandle as int, TrueFalse as int);
     declare import, xdbFieldPadding_Z Alias "XDBFIELDPADDING_Z" (DBFhandle as int, TrueFalse as int);

// ----------------------------------------------------------------------------------------------------
// INDEX ROUTINES - Creation/Opening/Closing 
// ----------------------------------------------------------------------------------------------------
     declare import, xdbCreateIndex Alias "XDBCREATEINDEX" (iFilename as string, dbHandle as int, IndexExpression as string, Duplicates as int);
     declare import, xdbCreateIndex_Z Alias "XDBCREATEINDEX_Z" (iFilename As string, dbHandle as int, IndexExpression As string, Duplicates as int);
     declare import, xdbOpenIndex Alias "XDBOPENINDEX" (iFilename as string, dbHandle as int), int;
     declare import, xdbOpenIndex_Z Alias "XDBOPENINDEX_Z" (iFilename As string, dbHandle as int), int;
     declare import, xdbCloseIndex Alias "XDBCLOSEINDEX" (DBFhandle as int, idxHandle as int);
     declare import, xdbCloseIndex_Z Alias "XDBCLOSEINDEX_Z" (DBFhandle as int, idxHandle as int);
     declare import, xdbReindex Alias "XDBREINDEX" (DBFhandle as int, idxHandle as int, opt ContinueOrError as int);
     declare import, xdbReindex_Z Alias "XDBREINDEX_Z" (DBFhandle as int, idxHandle as int, opt ContinueOrError as int);
     declare import, xdbReindexAll Alias "XDBREINDEXALL" (DBFhandle as int, opt ContinueOrError as int);
     declare import, xdbReindexAll_Z Alias "XDBREINDEXALL_Z" (DBFhandle as int, opt ContinueOrError as int);
     declare import, xdbSeek Alias "XDBSEEK" (DBFhandle as int, idxHandle as int, LookForKey as string), int;
     declare import, xdbSeek_Z Alias "XDBSEEK_Z" (DBFhandle as int, idxHandle as int, LookForKey As string), int;
     declare import, xdbSeekNext Alias "XDBSEEKNEXT" (dbHandle as int, idxHandle as int, LookForKey as string), int;
     declare import, xdbSeekNext_Z Alias "XDBSEEKNEXT_Z" (dbHandle as int, idxHandle as int, LookForKey As string), int;
     declare import, xdbSeekPartial Alias "XDBSEEKPARTIAL" (dbHandle as int, idxHandle as int, LookForKey as string), int;
     declare import, xdbSeekPartial_Z Alias "XDBSEEKPARTIAL_Z" (dbHandle as int, idxHandle as int, LookForKey As string), int;
     declare import, xdbSeekPartialNext Alias "XDBSEEKPARTIALNEXT" (dbHandle as int, idxHandle as int, LookForKey as string), int;
     declare import, xdbSeekPartialNext_Z Alias "XDBSEEKPARTIALNEXT_Z" (dbHandle as int, idxHandle as int, LookForKey As string), int;
     declare import, xdbSetCallback Alias "XDBSETCALLBACK" (hWnd as int);
     declare import, xdbSetCallback_Z Alias "XDBSETCALLBACK_Z" (hWnd as int);

// ----------------------------------------------------------------------------------------------------
// INDEX ROUTINES - Index information 
// ----------------------------------------------------------------------------------------------------
     declare import, xdbKeyLength Alias "XDBKEYLENGTH" (DBFhandle as int, idxHandle as int), int;
     declare import, xdbKeyLength_Z Alias "XDBKEYLENGTH_Z" (DBFhandle as int, idxHandle as int), int;
     declare import, xdbKeyCount Alias "XDBKEYCOUNT" (DBFhandle as int, idxHandle as int), int;
     declare import, xdbKeyCount_Z Alias "XDBKEYCOUNT_Z" (DBFhandle as int, idxHandle as int), int;
     declare import, xdbKeyUnique Alias "XDBKEYUNIQUE" (DBFhandle as int, idxHandle as int), int;
     declare import, xdbKeyUnique_Z Alias "XDBKEYUNIQUE_Z" (DBFhandle as int, idxHandle as int), int;
     declare import, xdbKeyExpression Alias "XDBKEYEXPRESSION" (DBFhandle as int, idxHandle as int);
     declare import, xdbKeyExpression_Z Alias "XDBKEYEXPRESSION_Z" (DBFhandle as int, idxHandle as int), int;
     declare import, xdbMKL Alias "XDBMKL" (LongValue as int);
     declare import, xdbMKL_Z Alias "XDBMKL_Z" (LongValue as int), int;
     declare import, xdbMKI Alias "XDBMKI" (IntegerValue as int);
     declare import, xdbMKI_Z Alias "XDBMKI_Z" (IntegerValue as int), int;

// ----------------------------------------------------------------------------------------------------
// QUERY ROUTINES 
// ----------------------------------------------------------------------------------------------------
     declare import, xdbCreateQuery Alias "XDBCREATEQUERY" (DBFhandle as int), int;
     declare import, xdbCreateQuery_Z Alias "XDBCREATEQUERY_Z" (DBFhandle as int), int;
     declare import, xdbQueryCondition Alias "XDBQUERYCONDITION" (QueryHandle as int, JoinPhrase as int, FieldName as string, Equality as int, vParameter1 as string, vParameter2 as string);
     declare import, xdbQueryCondition_Z Alias "XDBQUERYCONDITION_Z" (QueryHandle as int, JoinPhrase as int, FieldName As string, Equality as int, vParameter1 As string, vParameter2 As string);
     declare import, xdbQuerySort Alias "XDBQUERYSORT" (QueryHandle as int, FieldName as string, SortDirection as int);
     declare import, xdbQuerySort_Z Alias "XDBQUERYSORT_Z" (QueryHandle as int, FieldName As string, SortDirection as int);
     declare import, xdbQueryExecute Alias "XDBQUERYEXECUTE" (QueryHandle as int);
     declare import, xdbQueryExecute_Z Alias "XDBQUERYEXECUTE_Z" (QueryHandle as int);
     declare import, xdbQuerySUM Alias "XDBQUERYSUM" (QueryHandle as int, FieldName as string), double;
     declare import, xdbQuerySUM_Z Alias "XDBQUERYSUM_Z" (QueryHandle as int, FieldName As string), double;
     declare import, xdbQueryMIN Alias "XDBQUERYMIN" (QueryHandle as int, FieldName as string), double;
     declare import, xdbQueryMIN_Z Alias "XDBQUERYMIN_Z" (QueryHandle as int, FieldName As string), double;
     declare import, xdbQueryMAX Alias "XDBQUERYMAX" (QueryHandle as int, FieldName as string), double;
     declare import, xdbQueryMAX_Z Alias "XDBQUERYMAX_Z" (QueryHandle as int, FieldName As string), double;
     declare import, xdbQueryAVG Alias "XDBQUERYAVG" (QueryHandle as int, FieldName as string), double;
     declare import, xdbQueryAVG_Z Alias "XDBQUERYAVG_Z" (QueryHandle as int, FieldName As string), double;
     declare import, xdbQueryDistinct Alias "XDBQUERYDISTINCT" (QueryHandle as int, DistinctFieldName as string);
     declare import, xdbQueryDistinct_Z Alias "XDBQUERYDISTINCT_Z" (QueryHandle as int, DistinctFieldName As string);
     declare import, xdbHtmlStripTag Alias "XDBHTMLSTRIPTAG" (QueryHandle as int, TrueFalse as int);
     declare import, xdbHtmlStripTag_Z Alias "XDBHTMLSTRIPTAG_Z" (QueryHandle as int, TrueFalse as int);
     declare import, xdbDestroyQuery Alias "XDBDESTROYQUERY" (QueryHandle as int);
     declare import, xdbDestroyQuery_Z Alias "XDBDESTROYQUERY_Z" (QueryHandle as int);
     declare import, xdbQueryIndex Alias "XDBQUERYINDEX" (QueryHandle as int), int;
     declare import, xdbQueryIndex_Z Alias "XDBQUERYINDEX_Z" (QueryHandle as int), int;

// ----------------------------------------------------------------------------------------------------
// DATE ROUTINES  
// ----------------------------------------------------------------------------------------------------
     declare import, xdbDaysApart Alias "XDBDAYSAPART" (DateFrom as string, DateTo as string), int;
     declare import, xdbDaysApart_Z Alias "XDBDAYSAPART_Z" (DateFrom As string, DateTo As string), int;
     declare import, xdbDaysInMonth Alias "XDBDAYSINMONTH" (Year as int, Month as int), int;
     declare import, xdbDaysInMonth_Z Alias "XDBDAYSINMONTH_Z" (Year as int, Month as int), int;
     declare import, xdbAddDate Alias "XDBADDDATE" (StartDate as string, Days as int);
     declare import, xdbAddDate_Z Alias "XDBADDDATE_Z" (StartDate As string, Days as int), int ;
     declare import, xdbNameOfDay Alias "XDBNAMEOFDAY" (DateCheck as string);
     declare import, xdbNameOfDay_Z Alias "XDBNAMEOFDAY_Z" (DateCheck As string), int ;
     declare import, xdbTodaysDate Alias "XDBTODAYSDATE" ();
     declare import, xdbTodaysDate_Z Alias "XDBTODAYSDATE_Z" (), int ;
     declare import, xdbValidDate Alias "XDBVALIDDATE" (DateCheck as string), int;
     declare import, xdbValidDate_Z Alias "XDBVALIDDATE_Z" (DateCheck As string), int;
     declare import, xdbDateToJulian Alias "XDBDATETOJULIAN" (DateString as string), int;
     declare import, xdbDateToJulian_Z Alias "XDBDATETOJULIAN_Z" (DateString As string), int;
     declare import, xdbJulianToDate Alias "XDBJULIANTODATE" (JulianNumber as int);
     declare import, xdbJulianToDate_Z Alias "XDBJULIANTODATE_Z" (JulianNumber as int), int ;
     declare import, CTOD Alias "CTOD" (PBDate As String), String;
     declare import, CTOD_Z Alias "CTOD_Z" (PBDate As string), int ;
     declare import, DTOS Alias "DTOS" (xDate As String), String ;
     declare import, DTOS_Z Alias "DTOS_Z" (xDate As string), int ;

// ----------------------------------------------------------------------------------------------------
// MISCELLANEOUS ROUTINES 
// ----------------------------------------------------------------------------------------------------
     declare import, xdbResetError Alias "XDBRESETERROR" ();
     declare import, xdbResetError_Z Alias "XDBRESETERROR_Z" ();
     declare import, xdbError Alias "XDBERROR" (), int;
     declare import, xdbError_Z Alias "XDBERROR_Z" (), int;
     declare import, xdbVersion Alias "XDBVERSION" ();
     declare import, xdbVersion_Z Alias "XDBVERSION_Z" (), int;
     declare import, xdbRegisteredTo Alias "XDBREGISTEREDTO" ();
     declare import, xdbRegisteredTo_Z Alias "XDBREGISTEREDTO_Z" (), int;
     declare import, xdbDebugMode Alias "XDBDEBUGMODE" (UserMode as int);
     declare import, xdbDebugMode_Z Alias "XDBDEBUGMODE_Z" (UserMode as int);
     declare import, xdbDebugReadStart Alias "XDBDEBUGREADSTART" ();
     declare import, xdbDebugReadEnd Alias "XDBDEBUGREADEND" ();
     declare import, xdbAppPath Alias "XDBAPPPATH" (), string;
     declare import, xdbAppPath_Z Alias "XDBAPPPATH_Z" (), int;
     declare import, xdbFreeDLL Alias "XDBFREEDLL" ();
     declare import, xdbFreeDLL_Z Alias "XDBFREEDLL_Z" ();
     declare import, xdbIsEncrypted Alias "XDBISENCRYPTED" (DBFhandle as int), int;
     declare import, xdbIsEncrypted_Z Alias "XDBISENCRYPTED_Z" (DBFhandle as int), int;
     declare import, xdbEncryptionMethod Alias "XDBENCRYPTIONMETHOD" (DBFhandle as int), int;
     declare import, xdbEncryptionMethod_Z Alias "XDBENCRYPTIONMETHOD_Z" (DBFhandle as int), int;
     declare import, xdbTempFileName Alias "XDBTEMPFILENAME" ();
     declare import, xdbTempFileName_Z Alias "XDBTEMPFILENAME_Z" (), int;
 

// ----------------------------------------------------------------------------------------------------
// EQUATES - General and Error Codes
// ----------------------------------------------------------------------------------------------------
     #define XDBTRUE 1                     
     #define XDBFALSE 0                    
     #define MAX_INDEXES           100   
     #define MAX_FIELDS            1000  
     #define MAX_CONDITIONS        50    
     #define MAX_INDEXKEYS         6     
     #define MAX_CHARFIELD_SIZE    256   
     #define MAX_NUMFIELD_SIZE     20    
     #define ENCRYPT_NONE          0     
     #define ENCRYPT_RC4           1     
     #define ENCRYPT_KEYEDXOR      2     
     #define ENCRYPT_SUPERSCRAMBLE 3     
     #define QUERY_AND 1  
     #define QUERY_OR  2  
     #define EQUAL_TO              1   
     #define NOT_EQUAL_TO          2   
     #define LESS_THAN             3   
     #define GREATER_THAN          4   
     #define LESS_THAN_EQUAL_TO    5   
     #define GREATER_THAN_EQUAL_TO 6   
     #define CONTAINS              7   
     #define BETWEEN               8   
     #define SUM                   9   
     #define MINIMUM               10  
     #define MAXIMUM               11  
     #define AVERAGE               12  
     #define WILDCARD              13  
     #define SORT_ASCEND           1   
     #define SORT_DESCEND          0   
     #define XDBREADONLY  0  
     #define XDBWRITEONLY 1  
     #define XDBREADWRITE 2  
     #define XDBDENYREADWRITE 1  
     #define XDBDENYWRITE     2  
     #define XDBDENYREAD      3  
     #define XDBDENYNONE      4  
     #define XDBUNIQUE_CONTINUE 0          
     #define XDBUNIQUE_ERROR 1             
     #define FILE_ACCESS_ERROR 4000        
     #define INVALID_DATE_FORMAT 4001      
     #define FILE_READ_ONLY 4002           
     #define FILE_WRITE_ONLY 4003          
     #define INVALID_FILENAME 4004         
     #define ENGINE_NOT_INITIALIZED 5000   
     #define FILE_NOT_FOUND 5001           
     #define TOO_MANY_FILES_OPEN 5002      
     #define INVALID_STRUCTURE 5003        
     #define FILE_NOT_OPEN 5004            
     #define RECORD_OUT_OF_RANGE 5005      
     #define FIELD_NOT_FOUND 5006          
     #define INVALID_FILE_HANDLE 5007      
     #define INVALID_FIELD_LENGTH 5008     
     #define DUPLICATE_ALIAS_NAME 5009     
     #define INVALID_ACCESSMODE 5010       
     #define INVALID_SHAREMODE 5011        
     #define RECORD_BUSY 5012              
     #define INCOMPATIBLE_MEMO_FIELDS 5013 
     #define RECORDSIZE_EXCEEDED 5014      
     #define INVALID_ENCRYPTIONKEY 5015    
     #define DATABASE_NOT_OPEN 7000        
     #define TOO_MANY_INDEXES_OPEN 7002    
     #define INVALID_KEY_EXPRESSION 7003   
     #define INDEX_NOT_OPEN 7004           
     #define INDEX_UNIQUE_KEYS_ONLY 7005   
     #define SEEK_NO_INDEX_SET 7006        
     #define INDEX_NOT_FOUND 7007          
     #define QUERY_NOT_GENERATED 9000         
     #define QUERY_INVALID_FIELDNAME 9001     
     #define QUERY_INVALID_COMPARISON 9002    
     #define QUERY_MISSING_DELIMITERS 9003    
     #define QUERY_MISSING_SEARCHSTRING 9004  
     #define QUERY_TOO_MANY_EXPRESSIONS 9005  
     #define QUERY_EXPECTED_NUMERIC_STRING 9006 
     #define QUERY_ERROR_GETRECORD 9007       
     #define QUERY_INVALID_HANDLE 9008        
     #define QUERY_INVALID_JOINPHRASE 9009    
     #define QUERY_NO_WILDCARD_FOUND 9010     //
     #define QUERY_INVALID_PARENTHESIS 9011   //
     #define DLL_EXPIRED 99999  
 
